#include <Wire.h>
#include "Sodaq_DS3231.h" //Librería para el módulo RTC DS3231.
//Lista para el día de la semana y nomenclatura de iniciación para configurar por primera vez el RTC
char DiaSemana[][4] = {"Dom", "Lun", "Mar", "Mie", "Jue", "Vie", "Sab" };
// La línea fija la fecha, hora y dia de la semana, se debe suprimir la linea en la segunda carga
// Ejemplo 2017 Julio 12,2:20:00 pm dia 1-Lunes (0=Dom, 1=Lun, 2=Mar, 3=Mie, 4=Jue, 5=Vie, 6=Sab)
DateTime dt(2024, 5, 9, 23, 17, 00, 4);
//// Inicialización del motor paso a paso.
//definicion de pines
const int pinMotor1 = 8; // 28BYJ48 - In1
const int pinMotor2 = 9; // 28BYJ48 - In2
const int pinMotor3 = 10; // 28BYJ48 - In3
const int pinMotor4 = 11; // 28BYJ48 - In4
//definicion variables
int velocidadMotor = 1000; // variable para determinar la velocidad
// 800 maxima - minima 1000 o mas
int contadorPasos = 0; // contador para los pasos
int pasosPorVuelta = 4076; // pasos para una vuelta completa
// Tablas con la secuencia de encendido
// quitar signo de comentar a la necesaria)

//secuencia 1-fase usar velocidadMotor = 2000
//const int cantidadPasos = 4;
//const int tablaPasos[4] = { B1000, B0100, B0010, B0001 };
//secuencia 2-fases usar velocidadMotor = 2000
//const int cantidadPasos = 4;
//const int tablaPasos[4] = { B1001, B1100, B0110, B0011 };
//secuencia media fase usar velocidadMotor = 1000
const int cantidadPasos = 8;
const int tablaPasos[8] = { B1000, B1100, B0100, B0110, B0010, B0011, B0001, B1001 };
//// Inicialización para el parlante con el módulo ISD1820.
// Definición del pin que activa la voz en el módulo ISD1829 como el pin 5.
int P_E = 11;
//// Inicialización para el motor DC >5V.
// Definición del pin que activa el motor como el pin 3.
int ControlPin = 3;
// Definición de la velocidad del motor.
int velMotor = 15;
//// Inicialización de la señal luminosa.
// Definición del pin que activa el led verde.
int ledVerde = 7;
// Definición del pin que activa el led rojo.
int ledRojo = 6;

//// Definición de la hora, minuto y segundo elegido para la distribución de la comida.
int horaElegida = 23;
int minutoElegido = 18;
int segundoElegido = 00;
void setup ()
{
Serial.begin(9600);
Wire.begin();
rtc.begin();
// La línea fija la fecha, hora y día de la semana, se debe suprimir la línea en la segunda carga
rtc.setDateTime(dt);
//Definición de los pines de los leds como de salida (OUTPUT).
pinMode(ledVerde, OUTPUT);
pinMode(ledRojo, OUTPUT);
//Definición de los pines del motor paso a paso como de salida (OUTPUT).
pinMode(pinMotor1, OUTPUT);
pinMode(pinMotor2, OUTPUT);
pinMode(pinMotor3, OUTPUT);
pinMode(pinMotor4, OUTPUT);
//Definición deel pin del módulo ISD1820 como de salida (OUTPUT).
pinMode(P_E, OUTPUT);
//Definición del pin del motor DC del tornillo como de salida (OUTPUT).
pinMode(ControlPin, OUTPUT);
/////////////////////////////////////////////////////////////////////////
}

void loop ()
{
Serial.print(rtc.getTemperature()); //Escribe la temperatura.
Serial.println("18*C");
DateTime now = rtc.now();
Serial.print(now.year(), DEC); //Escribe el año.
Serial.print('/');
Serial.print(now.month(), DEC); //Escribe el mes.
Serial.print('/');
Serial.print(now.date(), DEC); //Escribe el día.
Serial.print(' ');
Serial.print(now.hour(), DEC); //Escribe la hora.
Serial.print(':');
Serial.print(now.minute(), DEC); //Escribe el minuto.
Serial.print(':');
Serial.print(now.second(), DEC); //Escribe el segundo.
Serial.print(' ');
Serial.print(DiaSemana[now.dayOfWeek()]); //Escribe el día de la semana.
Serial.println();
rtc.convertTemperature(); //Convierte el registro de la temperatura.
//Condición para encender el sistema de alarma, rotación y distribución
if ( now.hour() == horaElegida && now.minute() == minutoElegido &&
now.second() == segundoElegido )
{
digitalWrite(ledVerde, HIGH);//Enciende el led verde.
digitalWrite(ledRojo, HIGH);//Enciende el led rojo.
digitalWrite(P_E, HIGH);//Enciende el módulo del parlante.
///////// Inicio sequencia del motor paso a paso ///////

for (int i = 0; i < pasosPorVuelta * (0.5); i++) //Este for hace medio giro en sentido antihorario
{
sentidoAntihorario();
delayMicroseconds(velocidadMotor);
}
delay(200);
for (int i = 0; i < pasosPorVuelta * (0.25); i++) //Este for hace un cuarto de giro en sentido horario
{
sentidoHorario();
delayMicroseconds(velocidadMotor);
}
delay(200);
for (int i = 0; i < pasosPorVuelta * (0.5); i++) //Este for hace medio giro en sentido antihorario
{
sentidoAntihorario();
delayMicroseconds(velocidadMotor);
}
delay(200);
for (int i = 0; i < pasosPorVuelta * (0.25); i++) //Este for hace un cuarto de giro en sentido horario
{
sentidoHorario();
delayMicroseconds(velocidadMotor);
}
delay(200);
for (int i = 0; i < pasosPorVuelta * (0.5); i++) //Este for hace medio giro en sentido antihorario
{
sentidoAntihorario();

delayMicroseconds(velocidadMotor);
}
delay(200);
for (int i = 0; i < pasosPorVuelta * (0.25); i++) //Este for hace un cuarto de giro en sentido horario
{
sentidoHorario();
delayMicroseconds(velocidadMotor);
}
delay(200);
for (int i = 0; i < pasosPorVuelta * (0.5); i++) //Este for hace medio giro en sentido antihorario
{
sentidoAntihorario();
delayMicroseconds(velocidadMotor);
}
delay(200);
for (int i = 0; i < pasosPorVuelta * (0.25); i++) //Este for hace un cuarto de giro en sentido horario
{
sentidoHorario();
delayMicroseconds(velocidadMotor);
}
delay(200);
///////// Fin sequencia del motor //////////
digitalWrite(ledVerde, LOW);//Apaga el led verde.
digitalWrite(ledRojo, HIGH);//Sigue el led rojo prendido.
digitalWrite(P_E, HIGH);//Sigue el parlante emitiendo un sonido
delay(5000);// Tiempo de espera para que pase al siguiente bloque de órdenes.

digitalWrite(7, LOW);//Apaga el led verde.

digitalWrite(6, LOW);//Apaga el led rojo.
digitalWrite(P_E, LOW);//Apaga el parlante.
delay(5000);
}else{//Bloque de órdenes que se ejecutan en caso de que no se cumpla la condición inicial (de la hora elegida)
digitalWrite(7, LOW);//Apaga el led verde.
digitalWrite(6, LOW);//Apaga el led rojo.
digitalWrite(P_E, LOW);//Apaga el parlante.
}
delay(800); // Tiempo en el que refresca la información
}
///////////////////////// Funciones del motor /////////////////////////////
void sentidoHorario() // en dirección de las agujas del reloj
{
contadorPasos++;
if (contadorPasos >= cantidadPasos) contadorPasos = 0;
escribirSalidas(contadorPasos);
}
void sentidoAntihorario()// en dirección contraria a las agujas del reloj
{
contadorPasos--;
if (contadorPasos < 0) contadorPasos = cantidadPasos - 1;
escribirSalidas(contadorPasos);
}
void escribirSalidas(int paso)
{
digitalWrite(pinMotor1, bitRead(tablaPasos[paso], 0));
digitalWrite(pinMotor2, bitRead(tablaPasos[paso], 1));
digitalWrite(pinMotor3, bitRead(tablaPasos[paso], 2));
digitalWrite(pinMotor4, bitRead(tablaPasos[paso], 3));

}
